/// <reference path="../../typings/tsd.d.ts"/>
import * as React from "react";
import * as RN from "react-native";
let ProgressBarAndroid = RN.ProgressBarAndroid;
import { View } from "./View";
import { ImageView } from "./ImageView";
import { ActivityIndicatorViewStyle } from "./Enum";
/**
 * ActivityIndicatorView
 */
export class ActivityIndicatorView extends View {
    view() {
        if (this.props.activityImage) {
            return (React.createElement(ImageView, {image: this.props.activityImage, style: [
                this.props.style,
                { opacity: (this.props.animating ? 1.0 : 0.0) },
            ]}));
        }
        else if (RN.Platform.OS == "android") {
            return (React.createElement(ProgressBarAndroid, {color: this.props.tintColor, styleAttr: this.props.activityStyle == ActivityIndicatorViewStyle.Default ? "Small" : "Inverse", style: {
                opacity: (this.props.animating ? 1.0 : 0.0)
            }}));
        }
        else if (RN.Platform.OS == "ios") {
            return (React.createElement(RN.ActivityIndicatorIOS, {color: this.props.tintColor, size: this.props.activityStyle == 0 ? "small" : "large", style: {
                opacity: (this.props.animating ? 1.0 : 0.0)
            }}));
        }
        else {
            return null;
        }
    }
}
ActivityIndicatorView.defaultProps = Object.assign({}, View.defaultProps, {
    activityStyle: ActivityIndicatorViewStyle.Large,
    animating: false,
});
