/// <reference path="../../typings/tsd.d.ts"/>
/**
 * Font
 */
export class Font {
    constructor() {
        this.pointSize = 15;
        this.fontWeight = "normal";
        this.fontStyle = "normal";
        this.familyName = undefined;
    }
    static fontWithSize(size) {
        let instance = new Font();
        instance.pointSize = size;
        return instance;
    }
    static boldSystemFontOfSize(size) {
        let instance = new Font();
        instance.pointSize = size;
        instance.fontWeight = "bold";
        return instance;
    }
    static italicSystemFontOfSize(size) {
        let instance = new Font();
        instance.pointSize = size;
        instance.fontStyle = "italic";
        return instance;
    }
    styles() {
        return {
            fontSize: this.pointSize,
            fontWeight: this.fontWeight,
            fontStyle: this.fontStyle,
            fontFamily: typeof this.familyName === "string" ? this.familyName : undefined,
        };
    }
}
