/// <reference path="../../typings/tsd.d.ts"/>
import * as React from "react";
import * as RN from "react-native";
import { View } from "./View";
import { Font } from "./Font";
import { TextAlignment } from "./Enum";
/**
 * Label
 */
export class Label extends View {
    textAlign() {
        switch (this.props.textAlignment) {
            case TextAlignment.Left:
                return "left";
            case TextAlignment.Center:
                return "center";
            case TextAlignment.Right:
                return "right";
        }
        return "left";
    }
    attrStyle() {
        return {
            color: this.props.textColor,
            textAlign: this.textAlign(),
        };
    }
    view() {
        if (this.props.children) {
            return this.props.children;
        }
        else {
            return (React.createElement(RN.Text, {style: [this.props.font.styles(), this.attrStyle()], numberOfLines: this.props.numberOfLines}, this.props.text));
        }
    }
}
Label.defaultProps = Object.assign({}, View.defaultProps, {
    text: "",
    font: Font.fontWithSize(15.0),
    textColor: "black",
    highlightedColor: null,
    textAlignment: TextAlignment.Left,
    numberOfLines: 9999,
});
