/// <reference path="../../typings/tsd.d.ts"/>
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import * as React from "react";
import { View } from "./View";
import { Image } from "./ImageView";
import { TextButton } from "./Button";
import { Label } from "./Label";
import { Font } from "./Font";
import { ImageRenderingMode, ControlEvents } from "./Enum";
/**
 * BarButtonItem
 */
export class BarButtonItem extends View {
    static backItem(handler, title, indicatorImage, tintColor) {
        let image = indicatorImage ? indicatorImage : Image.resource(require('./Assets/ux_back.png')).imageWithRenderingMode(ImageRenderingMode.Template);
        return React.createElement(BarButtonItem, {image: image, title: title && title.length < 4 ? title : "返回", middleInset: 4.0, tintColor: tintColor, handler: handler});
    }
    render() {
        return (React.createElement(TextButton, {margin: { left: 8, right: 8 }, middleInset: this.props.middleInset, style: { flex: 1, paddingLeft: 0, paddingRight: 0 }, title: this.props.title, image: this.props.image, tintColor: this.props.tintColor, titleLabelProps: { font: Font.fontWithSize(16.0) }, backTouchingArea: this.props.backTouchingArea, handler: this.props.handler}));
    }
}
BarButtonItem.defaultProps = Object.assign({}, View.defaultProps, {
    title: null,
    image: null,
    middleInset: 0.0,
    backTouchingArea: 0.0,
    handler: () => { }
});
/**
 * NavigationItem
 */
export class NavigationItem {
    barProps(navigationController) {
        if (!!!navigationController || !!!navigationController.props.navigationBarProps) {
            return {};
        }
        return navigationController.props.navigationBarProps;
    }
    resetTitleView(title, navigationController) {
        this.titleView = (React.createElement(Label, __assign({frame: { cx: 0, cy: 0 }, text: title, font: Font.boldSystemFontOfSize(17.0)}, this.barProps(navigationController).titleLabelProps)));
    }
    resetBackButtonItem(title, navigationController) {
        this.backBarButtonItem = BarButtonItem.backItem((event) => {
            if (event == ControlEvents.TouchUpInside) {
                navigationController.popViewController();
            }
        }, title, this.barProps(navigationController).backIndicatorImage, this.barProps(navigationController).tintColor);
    }
}
