/// <reference path="../../typings/tsd.d.ts"/>
import * as React from "react";
import * as RN from "react-native";
import { View } from "./View";
/**
 * PageControl
 */
export class PageControl extends View {
    view() {
        let items = [];
        for (var i = 0; i < this.props.numberOfPages; i++) {
            items.push(React.createElement(View, {key: "item_" + i, style: {
                backgroundColor: (i == this.props.currentPage ? this.props.currentPageIndicatorTintColor : this.props.pageIndicatorTintColor),
                borderRadius: 4.0,
                height: 8,
                width: 8,
                marginLeft: 4,
                marginRight: 4
            }}));
        }
        return (React.createElement(View, {frame: { x: 0, y: 0, mx: 0, my: 0 }, userInteractionEnabled: false}, React.createElement(RN.View, {style: { flexDirection: "row", justifyContent: "center" }}, items)));
    }
}
PageControl.defaultProps = Object.assign({}, View.defaultProps, {
    numberOfPages: 0,
    currentPage: 0,
    hidesForSinglePage: true,
    pageIndicatorTintColor: "#ffffff80",
    currentPageIndicatorTintColor: "#ffffff",
    frame: { height: 8.0 }
});
