/// <reference path="../../typings/tsd.d.ts"/>
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import * as React from "react";
import * as RN from "react-native";
import { ViewController } from "./ViewController";
import { ScrollView } from "./ScrollView";
import { ScrollDirection } from "./Enum";
/**
 * PageViewController
 */
export class PageViewController extends ViewController {
    constructor(...args) {
        super(...args);
        this.viewControllers = [];
        this.currentPage = 0;
    }
    viewWillLayoutSubviews() {
        this.forceUpdate();
    }
    loadView() {
        let viewControllers = this.props.viewControllers || this.viewControllers;
        let vcElements = viewControllers.map((item, idx) => {
            return (React.createElement(RN.View, {key: "vc_" + idx, style: { width: this.bounds.width, height: this.bounds.height }}, item));
        });
        return (React.createElement(ScrollView, __assign({delegate: this, contentSize: { width: this.bounds.width * viewControllers.length, height: this.bounds.height }, scrollDirection: ScrollDirection.Horizontal, pageEnabled: true, showsHorizontalScrollIndicator: false}, this.props.scrollViewProps), React.createElement(RN.View, {style: { flexDirection: 'row' }}, vcElements)));
    }
    scrollViewDidScroll(scrollView) {
        if (scrollView.contentOffset.x % scrollView.bounds.width <= 1.0) {
            let tPage = Math.round(scrollView.contentOffset.x / scrollView.bounds.width);
            if (tPage != this.currentPage) {
                this.currentPage = tPage;
                this.props.delegate && this.props.delegate.pageViewControllerDidScrollToPage && this.props.delegate.pageViewControllerDidScrollToPage(tPage, this);
            }
        }
    }
}
