/// <reference path="../../typings/tsd.d.ts"/>
import * as React from "react";
import * as RN from "react-native";
import { View } from "./View";
import { PresetColor } from "./Types";
/**
 * PixelLine
 */
export class PixelLine extends View {
    render() {
        let colorStyle = {};
        if (this.props.vertical) {
            colorStyle.borderRightColor = this.props.color;
        }
        else {
            colorStyle.borderBottomColor = this.props.color;
        }
        return (React.createElement(View, {style: [this.props.vertical ? styles.vertical : styles.horizon, colorStyle, this.props.style]}));
    }
}
PixelLine.defaultProps = Object.assign({}, View.defaultProps, {
    vertical: false,
    color: PresetColor.lineColor,
});
const styles = RN.StyleSheet.create({
    vertical: {
        borderRightWidth: RN.StyleSheet.hairlineWidth,
    },
    horizon: {
        borderBottomWidth: RN.StyleSheet.hairlineWidth,
    },
});
