/// <reference path="../../typings/tsd.d.ts"/>
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import * as React from "react";
import * as RN from "react-native";
import { View } from "./View";
import { TextField, TextFieldView } from "./TextField";
import { TextButton } from "./Button";
import { Image } from "./ImageView";
import { ImageRenderingMode, TextFieldViewMode, ControlEvents, GestureRecognizerState } from "./Enum";
import { PresetColor } from "./Types";
import { TapGestureRecognizer } from "./GestureRecognizer";
/**
 * SearchBarIconView
 */
class SearchBarIconView extends TextFieldView {
    view() {
        return (React.createElement(TextButton, {image: Image.resource(require("./Assets/ux_search.png")).imageWithRenderingMode(ImageRenderingMode.Template), tintColor: PresetColor.thirdTextColor, frame: { width: 22 }, contentHorizontalAlignment: "center", contentVerticalAlignment: "center", style: { flex: 1 }, handler: this.props.handler}));
    }
}
/**
 * SearchBar
 */
export class SearchBar extends TextField {
    onBeginEditing() {
        View.setLayout(() => {
            super.onBeginEditing();
        }, 200, 'timing');
    }
    onEndEditing() {
        View.setLayout(() => {
            super.onEndEditing();
        }, 200, 'timing');
    }
    view() {
        let shouldCenter = this.props.centerPlaceholder && this.text.length == 0 && !this.isFirstResponder;
        let iconX = shouldCenter ? (this.bounds.width - this.props.placeholderWidth) / 2.0 : 0.0;
        let textInputX = shouldCenter ? (this.bounds.width - this.props.placeholderWidth) / 2.0 : 0.0;
        let style = this.textFieldStyle();
        let leftView = this.leftView();
        style.marginLeft = leftView !== null ? leftView.props.width : 0.0;
        let rightView = this.rightView();
        style.marginRight = rightView !== null ? rightView.props.width : 0.0;
        return (React.createElement(View, {frame: { x: 0, y: 0, mx: 0, my: 0 }, alpha: this.bounds.width < 1.0 ? 0.0 : 1.0, gestureRecognizers: [
            new TapGestureRecognizer((state) => {
                if (state == GestureRecognizerState.Ended && !this.isFirstResponder) {
                    this.becomeFirstResponder();
                }
            })
        ]}, React.createElement(View, {frame: { x: 0, y: 0, mx: (this.isFirstResponder ? 44.0 : 0.0), my: 0 }, animatable: true}, React.createElement(View, {padding: { left: textInputX }, style: { flex: 1 }, animatable: true}, React.createElement(RN.TextInput, __assign({style: [style, this.props.font.styles()], editable: this.props.enabled, defaultValue: this.props.initText, placeholder: this.props.placeholderText, maxLength: this.props.maxLength, ref: "TextInput"}, this.textFieldProps()))), React.createElement(View, __assign({frame: { x: 0, y: 0, mx: 0, height: 30 }}, this.backgroundStyle()), React.createElement(View, {frame: { x: iconX, y: 0, my: 0 }, style: { flexDirection: "row" }, animatable: true}, leftView), React.createElement(View, {frame: { mx: 0, y: 0, my: 0 }, style: { flexDirection: "row" }}, rightView))), React.createElement(View, {frame: { y: 0, mx: (this.isFirstResponder ? 0.0 : -44.0), width: 44, height: 30 }, alpha: this.isFirstResponder ? 1.0 : 0.0, style: { flexDirection: "row" }, animatable: true}, React.createElement(TextButton, {title: "取消", titleLabelProps: { font: this.props.font }, style: { flex: 1 }, tintColor: this.props.tintColor, handler: (event) => {
            if (event == ControlEvents.TouchUpInside) {
                this.props.onCancel(this);
            }
        }}))));
    }
}
SearchBar.defaultProps = Object.assign({}, TextField.defaultProps, {
    showsCancelButton: false,
    showsCancelButtonWhileEditing: true,
    centerPlaceholder: true,
    onCancel: (sender) => {
        sender.resignFirstResponder();
    },
    leftView: (React.createElement(SearchBarIconView, {mode: TextFieldViewMode.Always, width: 14.0})),
    placeholderWidth: 22.0,
    boundsRelative: true,
});
