/// <reference path="../../typings/tsd.d.ts"/>
import * as React from "react";
import * as RN from "react-native";
import { View } from "./View";
import { TextButton } from "./Button";
import { Image } from "./ImageView";
import { ControlEvents, ImageRenderingMode } from "./Enum";
/**
 * Slider
 */
export class Stepper extends View {
    constructor(props) {
        super(props);
        this.numberValue = props.initValue;
    }
    componentWillReceiveProps(newProps) {
        super.componentWillReceiveProps(newProps);
        if (typeof this.props.currentValue === "number") {
            this.setValue(this.props.currentValue);
        }
    }
    value() {
        return this.numberValue;
    }
    setValue(value) {
        this.numberValue = value;
        this.forceUpdate();
    }
    view() {
        console.log(this.numberValue);
        return (React.createElement(View, {frame: { y: (44.0 - 28.0) / 2.0, x: 0, mx: 0, height: 28.0 }, cornerRadius: 4.0, borderColor: this.props.tintColor, borderWidth: 1.0}, React.createElement(RN.View, {style: { flexDirection: "row", flex: 1 }}, React.createElement(TextButton, {tintColor: this.props.tintColor, image: Image.resource(require('./Assets/ux_stepper_minus.png')).imageWithRenderingMode(ImageRenderingMode.Template), style: { flex: 1 }, enabled: this.numberValue > this.props.minValue, moveAllow: 44.0, handler: this.handleMinus.bind(this)}), React.createElement(RN.View, {style: { flex: 0, width: 1, backgroundColor: this.props.tintColor }}), React.createElement(TextButton, {tintColor: this.props.tintColor, image: Image.resource(require('./Assets/ux_stepper_add.png')).imageWithRenderingMode(ImageRenderingMode.Template), style: { flex: 1 }, enabled: this.numberValue < this.props.maxValue, moveAllow: 44.0, handler: this.handlePlus.bind(this)}))));
    }
    handleMinus(event) {
        if (event == ControlEvents.TouchUpInside) {
            if (this.numberValue - this.props.step >= this.props.minValue) {
                this.numberValue = this.numberValue - this.props.step;
                this.props.handler(this.numberValue);
                this.forceUpdate();
            }
        }
    }
    handlePlus(event) {
        if (event == ControlEvents.TouchUpInside) {
            if (this.numberValue + this.props.step <= this.props.maxValue) {
                this.numberValue = this.numberValue + this.props.step;
                this.props.handler(this.numberValue);
                this.forceUpdate();
            }
        }
    }
}
Stepper.defaultProps = Object.assign({}, View.defaultProps, {
    initValue: 0,
    currentValue: 0,
    minValue: 0,
    maxValue: 100,
    step: 1,
    handler: (newValue) => { },
    frame: { width: 94.0, height: 44.0 },
});
