/// <reference path="../../typings/tsd.d.ts"/>
import { KeyboardType, ReturnKeyType } from "./Enum";
let keyboardTypeProps = function (enumValue) {
    switch (enumValue) {
        case KeyboardType.Default:
            return "default";
        case KeyboardType.NumberPad:
            return "numeric";
        case KeyboardType.EmailAddress:
            return "email-address";
    }
    return "default";
};
let returnKeyTypeProps = function (enumValue) {
    switch (enumValue) {
        case ReturnKeyType.Default:
            return "default";
        case ReturnKeyType.Go:
            return "go";
        case ReturnKeyType.Next:
            return "next";
        case ReturnKeyType.Search:
            return "search";
        case ReturnKeyType.Send:
            return "send";
        case ReturnKeyType.Done:
            return "done";
    }
    return "default";
};
export let TextInputTraitsProps = (obj) => {
    return {
        autoCapitalize: obj.autocapitalizationType ? "sentences" : "none",
        autoCorrect: obj.autocorrectionType,
        secureTextEntry: obj.secureTextEntry,
        keyboardType: keyboardTypeProps(obj.keyboardType),
        returnKeyType: returnKeyTypeProps(obj.returnKeyType),
    };
};
