/// <reference path="../../typings/tsd.d.ts"/>
import * as React from "react";
import * as RN from "react-native";
import { View } from "./View";
import { ProgressView } from "./ProgressView";
/**
 * WebView
 */
export class WebView extends View {
    constructor(...args) {
        super(...args);
        this.loaded = false;
    }
    view() {
        return (React.createElement(RN.View, {style: { flex: 1 }}, React.createElement(RN.WebView, {source: this.props.source, allowsInlineMediaPlayback: true, style: { flex: 1 }, onLoadStart: () => { this.onLoadStart(); }, onLoad: () => { this.onLoad(); }, onError: () => { this.onError(); }}), React.createElement(ProgressView, {ref: "PV", frame: { x: 0, mx: 0, y: 0, height: 2 }, initProgress: 0.0})));
    }
    onLoadStart() {
        this.loaded = false;
        let progressView = this.refs["PV"];
        if (progressView instanceof ProgressView) {
            progressView.setProgress(0.60, true);
            RN.InteractionManager.runAfterInteractions(() => {
                this.onLoading(0.70);
            });
        }
    }
    onLoading(progress) {
        if (!this.loaded && progress <= 0.9) {
            let progressView = this.refs["PV"];
            if (progressView instanceof ProgressView) {
                progressView.setProgress(progress, true);
                RN.InteractionManager.runAfterInteractions(() => {
                    this.onLoading(progress + 0.10);
                });
            }
        }
    }
    onLoad() {
        this.loaded = true;
        let progressView = this.refs["PV"];
        if (progressView instanceof ProgressView) {
            progressView.setProgress(1.0, true);
        }
    }
    onError() {
        this.loaded = true;
        let progressView = this.refs["PV"];
        if (progressView instanceof ProgressView) {
            progressView.setProgress(0.0, false);
        }
    }
}
WebView.defaultProps = Object.assign({}, View.defaultProps, {
    style: { flex: 1 }
});
